/**
 * This class represents an extension of the HAPI Message
 */

package gov.nist.hl7maker.control;

// JDK
import java.io.File;
import java.io.IOException;

// DOM
import org.w3c.dom.Document;

// XML
import javax.xml.parsers.DocumentBuilder; 
import javax.xml.parsers.DocumentBuilderFactory;  
import javax.xml.parsers.ParserConfigurationException;

// SAX
import org.xml.sax.SAXException;  

// HAPI
/*import ca.uhn.hl7v2.parser.XMLParser;
import ca.uhn.hl7v2.parser.DefaultXMLParser;
import ca.uhn.hl7v2.model.Message;
import ca.uhn.hl7v2.HL7Exception;*/

public class MakerMessage {

    //protected Message msg;
    protected String filename;
    protected String profile;

    public static final int SAVED = 0; // means message saved
    public static final int GENERATED = 1; // means message was generated but not saved

    protected int status;

    /**
     * Constructor (create a MakerMessage from the filename)
     * @param filename The filename of the message
     */
    public MakerMessage(String filename) {
	this(filename, "");
    }

    /**
     * Constructor (create a MakerMessage from the filename and profile)
     * @param filename The filename of the message
     * @param profile The profile of the message
     */
    public MakerMessage(String filename, String profile) {
	//	try {
	    this.filename = filename;
	    this.profile = profile;
	    // Create a Document object
/*	    DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
	    DocumentBuilder builder = factory.newDocumentBuilder();
	    Document doc = builder.parse(new File(filename));

	    // Convert this Document in a Message object 
	    XMLParser xmlParser = new DefaultXMLParser();
	    msg = xmlParser.parseDocument(doc, "2.4");*/
	    status = 0;
	    //}
	/*catch(ParserConfigurationException pce) {
	    System.err.println("ParserConfigurationException " + pce.getMessage());
	}
	catch(SAXException saxe) {
	    System.err.println("SAXException " + saxe.getMessage());
	}
	catch(IOException ioe) {
	    System.err.println("IOException " + ioe.getMessage());
	    }*/
	/*catch(HL7Exception hl7e) {
	    System.err.println("HL7Exception " + hl7e.getMessage());
	    }*/
    }

    /*public MakerMessage(Message msg) {
	this.msg = msg;
	}*/

    public String getFilename() {
	return filename;
    }

    public void setStatus(int ss) {
	status = ss;
    }

    public int getStatus() {
	return status;
    }

    /*public Message getMessage() {
	return msg;
	}*/

    public String getProfile() {
	return profile;
    }
/* public String toString() {
return filename;
}*/

    public boolean equals(Object o) {
	if(o instanceof MakerMessage) {
	    MakerMessage mm = (MakerMessage)o;
	    return mm.getFilename().equals(filename);
	}
	return false;
    }
}
