
package gov.nist.hl7maker.control;

import gov.nist.hl7maker.util.Constants;

import java.io.*;
import java.util.*;

/*
 * TODO: make the location of the properties file dynamic
 * Normally, you can put property files on a relative or absolute path. But 
 * if you desire more location independence and flexibility, you can also put 
 * them on the CLASSPATH and get an InputStream like this:
 *
 *   this.getClass().getClassLoader().getResourceAsStream("my.properties");
 * 
 * I have an example of this under the programming/java/util directory. We may
 * need to do it this way.
 * 
 */

public class MakerProperties {

  private static final String propertiesFile =  
    "config" + Constants.FS + "Maker.properties";
  private static Properties properties = null;
  
  public MakerProperties() {
    
    loadMakerProperties();    
    //Debug
    //properties.list(System.out);
      
  }

  private static void loadMakerProperties () {

    FileInputStream in = null;

    properties = new Properties();
    
    try {
      in = new FileInputStream(propertiesFile);
      
      properties.load(in);
    }
    catch (FileNotFoundException e) {
    }
    catch (IOException e) {
    }
    catch (Exception e) {
    }
    
    //Debug
    //System.out.println("Default property values:");
    //properties.list(System.out);

    for (Enumeration e = properties.propertyNames(); e.hasMoreElements();) {
      String name = (String)e.nextElement();
      String prop = properties.getProperty(name);
      //System.out.println("   " + name + " = " +prop);
    }
 }

  /*
   * Return a Properties object.
   */
                                                                                
  public Properties getProperties() {
    return properties;
  }

  
}
