/**
 * This class represents a constant value from the profile
 */

package gov.nist.hl7maker.control;

public class ProfileConstantValue {

    protected String name;
    protected String qualifier;
    protected String qualifier2;
    protected String segment;

    protected String value;

    /**
     * Constructor
     */
    public ProfileConstantValue() {
    }

    // Get Methods
    public String getName() {
	return name;
    }

    public String getQualifier() {
	return qualifier;
    }

    public String getQualifier2() {
	return qualifier2;
    }

    public String getSegment() {
	return segment;
    }

    public String getValue() {
	return value;
    }

    // Set Methods
    public void setName(String name) {
	this.name = name;
    }

    public void setQualifier(String qualifier) {
	this.qualifier = qualifier;
    }

    public void setQualifier2(String qualifier2) {
	this.qualifier2 = qualifier2;
    }

    public void setSegment(String segment) {
	this.segment = segment;
    }

    public void setValue(String value) {
	this.value = value;
    }

    // Methods
    public String toString() {
	return name;
    }

    /**
     * Return true if the two objects are equal
     * @param o The other object
     * @return return true if equal
     */
    public boolean equals(Object o) {
	ProfileConstantValue pcv = (ProfileConstantValue)o;
	boolean equal = true;

	if(name.compareTo(pcv.getName()) != 0)
	    equal = false;
	if(qualifier.compareTo(pcv.getQualifier()) != 0)
	    equal = false;
	if(qualifier2.compareTo(pcv.getQualifier2()) != 0)
	    equal = false;
	if(segment.compareTo(pcv.getSegment()) != 0)
	    equal = false;
	return equal;
    }
}
