/**
 * This class represents an example value from the profile
 */

package gov.nist.hl7maker.control;

// JDK
import java.util.Vector;

public class ProfileExampleValue {

    protected String name;
    protected String qualifier;
    protected String qualifier2;
    protected String segment;

    protected Vector vValue;

    /**
     * Constructor
     */
    public ProfileExampleValue() {
	vValue = new Vector();
    }

    // Get Methods
    public String getName() {
	return name;
    }

    public String getQualifier() {
	return qualifier;
    }

    public String getQualifier2() {
	return qualifier2;
    }

    public String getSegment() {
	return segment;
    }

    public Vector getValues() {
	return vValue;
    }

    // Set Methods
    public void setName(String name) {
	this.name = name;
    }

    public void setQualifier(String qualifier) {
	this.qualifier = qualifier;
    }

    public void setQualifier2(String qualifier2) {
	this.qualifier2 = qualifier2;
    }

    public void setSegment(String segment) {
	this.segment = segment;
    }

    // Methods
    public String toString() {
	return name;
    }

    public void addValue(String value) {
	if(value != null && !vValue.contains(value))
	    vValue.add(value);
    }

    /**
     * Return true if the two objects are equal
     * @param o The other object
     * @return return true if equal
     */
    public boolean equals(Object o) {
	ProfileExampleValue pev = (ProfileExampleValue)o;
	boolean equal = true;

	if(name.compareTo(pev.getName()) != 0)
	    equal = false;
	if(qualifier.compareTo(pev.getQualifier()) != 0)
	    equal = false;
	if(qualifier2.compareTo(pev.getQualifier2()) != 0)
	    equal = false;
	if(segment.compareTo(pev.getSegment()) != 0)
	    equal = false;
	return equal;
    }
}
