/*
 * Created on May 18, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package gov.nist.hl7maker.message;

import gov.nist.hl7maker.util.MMLog;

import java.util.Properties;

/**
 * @author gebase
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class MessageOptions extends Options {
  // 'properties' must include all required message generation 
  //    options 
  public MessageOptions (Properties properties)
  throws IllegalArgumentException {
    super(properties);
    if (getProperty("valid") == null) {
      MMLog.error("Options not set: 'valid' option missing!");
      throw(new IllegalArgumentException("'valid' option missing!"));
    }
  }
  
  public void setOption (String name, String value)
  throws IllegalArgumentException {
    if ("valid".equalsIgnoreCase(name)) super.setProperty(name, value);
    else super.setOption(name, value);
  }
  
  public String getOption (String name)
  throws IllegalArgumentException {
    if ("valid".equalsIgnoreCase(name)) return super.getProperty(name);
    else return super.getOption(name);
  }
  
  public MessageOptions options2TransformOptions () {
    MessageOptions toptions = new MessageOptions(this);

    // no changes to these properties:
    toptions.setOption("valid", getProperty("valid"));
    toptions.setOption("starValue", getProperty("starValue"));
    toptions.setOption("offset", getProperty("offset"));
    toptions.setOption("messageControlId", getProperty("messageControlId"));
    toptions.setOption("segmentName", getProperty("segmentName"));
    toptions.setOption("fieldName", getProperty("fieldName"));
    toptions.setOption("componentName", getProperty("componentName"));
    toptions.setOption("subComponentName", getProperty("subComponentName"));
    toptions.setOption("cardinality", getProperty("cardinality"));
    toptions.setOption("REinclude", getProperty("REinclude"));
    toptions.setOption("elementErrorCode", getProperty("elementErrorCode"));

    String segmentCardinality = toptions.getProperty("segmentCardinality");
    String fieldCardinality = toptions.getProperty("fieldCardinality");
    String RE_Usage = toptions.getProperty("RE_Usage");
    String lengthConstraints = toptions.getProperty("lengthConstraints");
    String compositeLength = toptions.getProperty("compositeLength");
    String minSegCardError = toptions.getProperty("minSegCardError");
    String maxSegCardError = toptions.getProperty("maxSegCardError");
    String minFieldCardError = toptions.getProperty("minFieldCardError");
    String maxFieldCardError = toptions.getProperty("maxFieldCardError");
    String RusageError = toptions.getProperty("RusageError");
    String XusageError = toptions.getProperty("XusageError");
    String fieldLengthError = toptions.getProperty("fieldLengthError");
    String componentLengthError = toptions.getProperty("componentLengthError");
    String subComponentLenError = toptions.getProperty("subComponentLengthError");

    //  these 2 aren't supported yet
    String C_Usage = "0";
    String CE_Usage = "0";
    
    //   xml values -> setOptions values:
    if ("MAX".equalsIgnoreCase(segmentCardinality)) 
      segmentCardinality = "1";
    else if ("MIN".equalsIgnoreCase(segmentCardinality)) 
      segmentCardinality = "0";
    else 
      segmentCardinality = "0.5";
    
    if ("MAX".equalsIgnoreCase(fieldCardinality)) 
      fieldCardinality = "1";
    else if ("MIN".equalsIgnoreCase(fieldCardinality)) 
      fieldCardinality = "0";
    else 
      fieldCardinality = "0.5";
    
    if ("ALL".equalsIgnoreCase(RE_Usage)) 
      RE_Usage = "1";
    else if ("NONE".equalsIgnoreCase(RE_Usage)) 
      RE_Usage = "0";
    else 
      RE_Usage = "0.5";

    if ("true".equalsIgnoreCase(lengthConstraints)) 
      lengthConstraints = "1";
    else 
      lengthConstraints = "0";

    if ("true".equalsIgnoreCase(compositeLength)) 
      compositeLength = "1";
    else 
      compositeLength = "0";

    if ("true".equalsIgnoreCase(minSegCardError)) minSegCardError = "-0.1";
    else minSegCardError = "0";
    if ("true".equalsIgnoreCase(maxSegCardError)) maxSegCardError = "-1";
    else maxSegCardError = "0";
    if ("true".equalsIgnoreCase( minFieldCardError)) minFieldCardError = "-0.1";
    else minFieldCardError = "0";
    if ("true".equalsIgnoreCase(maxFieldCardError)) maxFieldCardError = "-1";
    else maxFieldCardError = "0";
    if ("true".equalsIgnoreCase(RusageError)) RusageError = "-0.1";
    else RusageError = "0";
    if ("true".equalsIgnoreCase(XusageError)) XusageError = "-0.1";
    else XusageError = "0";
    if ("true".equalsIgnoreCase(fieldLengthError)) fieldLengthError = "-0.1";
    else fieldLengthError = "0";
    if ("true".equalsIgnoreCase(componentLengthError)) componentLengthError = "-0.1";
    else componentLengthError = "0";
    if ("true".equalsIgnoreCase(subComponentLenError)) subComponentLenError = "-0.1";
    else subComponentLenError = "0";

    toptions.setOption("segmentCardinality", 
                              segmentCardinality);
    toptions.setOption("fieldCardinality", 
                              fieldCardinality);
    toptions.setOption("lengthConstraints", 
                              lengthConstraints);
    toptions.setOption("RE_Usage", RE_Usage);
    //toptions.setOption("C_Usage", C_Usage);
    //toptions.setOption("CE_Usage", CE_Usage);
    toptions.setOption("lengthConstraints",  
                              lengthConstraints);   
    toptions.setOption("compositeLength", compositeLength);     

    toptions.setOption("minSegCardError", minSegCardError);
    toptions.setOption("maxSegCardError", maxSegCardError);
    toptions.setOption("minFieldCardError", minFieldCardError);
    toptions.setOption("maxFieldCardError", maxFieldCardError);
    toptions.setOption("RusageError", RusageError);
    toptions.setOption("XusageError", XusageError);
    toptions.setOption("fieldLengthError", fieldLengthError);
    toptions.setOption("componentLengthError", componentLengthError);
    toptions.setOption("subComponentLengthError", subComponentLenError);

    // .......  these should get removed .....
    //String R_Usage = "1";   //  include all
    //String X_Usage = "0";   //  include none
    //toptions.setOption("Rusage", R_Usage);
    //toptions.setOption("Xusage", X_Usage);

    return new MessageOptions(toptions);  
  }
}
