/*
 * MAKFileFilter.java
 *
 * Created on June 29, 2004
 */

package gov.nist.hl7maker.util;

/**
 *
 * @author  Rob Snelick
 * Extend the File Filter class so that only certain extensions are allowed with
 * use in the File Chooser. Here we limit this to MMK files only.
 *
 * MMK files are Message Maker files.
 *
 */
public class MMKFileFilter extends javax.swing.filechooser.FileFilter {
  
  public boolean accept(java.io.File f) {
    
    if (f.isDirectory()) {
      return true;
    }

    String extension = ExtUtils.getExtension(f);
    if (extension != null) {
      if (extension.equals(ExtUtils.mmk)) {
        return true;
      } else {
        return false;
      }
    }
    return false;
  }
 
  public String getDescription() {
    return ("MMK files");
  }
  
}
