
package gov.nist.hl7maker.util;

import java.io.*;
import java.util.Calendar;
import org.w3c.dom.*; 
import ca.uhn.hl7v2.model.Message;
import java.util.*;

//Import log4j classes.
import org.apache.log4j.*;
//import org.apache.log4j.Logger;
//import org.apache.log4j.Level;
//import org.apache.log4j.BasicConfigurator;
//import org.apache.log4j.PatternLayout;
//import org.apache.log4j.spi.LoggerRepository;
import org.apache.log4j.xml.DOMConfigurator;

public class MMLog 
{
  /*
  final static boolean logging = true;
  final static boolean debugging = false;
  
  final static Calendar cal = Calendar.getInstance();
  final static long init_time = cal.getTimeInMillis();
  
  static FileOutputStream fOutStream = null;
  static PrintWriter logPW = null;

  static {
    initialization: {
      try {
        fOutStream = new FileOutputStream(logfile);
        logPW = new PrintWriter(fOutStream, true);
        logPW.println(cal.getTime());
      }
      catch (IOException e) {
        System.err.println("MMLog: initialization **ERROR** Exception: " +e);
      }
      catch (Exception e) {
        System.err.println("MMLog: initialization **ERROR** Exception: " +e);
      }
    }
  }
*/
  
  final static String logfile = "log" +Constants.FS +"msgGeneration.log";  
  static Logger consoleLogger = Logger.getLogger(MMLog.class);
  static Logger mmLogger = Logger.getLogger(logfile);

  static {
    initialization: {
      Calendar cal = Calendar.getInstance();
      
      Logger root = Logger.getRootLogger();
      root.setLevel(Level.OFF);

      //BasicConfigurator.configure();
      DOMConfigurator.configure("log4j.xml");

      PatternLayout pl = new PatternLayout("%r [%t] %-5p %c - %m%n");

      ConsoleAppender console = new ConsoleAppender(pl);

      FileAppender fappender = null;
      try {
        fappender = new FileAppender(pl, logfile, false);
      }
      catch (IOException e) {
        System.err.println("couldn't open " +logfile);
      }

      mmLogger.addAppender(fappender);
      mmLogger.setAdditivity(false);
      mmLogger.setLevel(Level.INFO);
      mmLogger.info(cal.getTime());
      root.addAppender(fappender);
      
/*      consoleLogger.error("C ERR Test Message Generator. Start...");
      mmLogger.error("F ERR Test Message Generator. Start...");
      consoleLogger.warn("C WARN Test Message Generator. Start...");
      mmLogger.warn("F Test WARN Message Generator. Start...");
      consoleLogger.info("C INFO Test Message Generator. Start...");
      mmLogger.info("F Test INFO Message Generator. Start...");
      consoleLogger.debug("C DEBUG Test Message Generator. Start...");
      mmLogger.debug("F DEBUG Test Message Generator. Start...");
*/    }
  }
    
/*  
  public static void log (String msg)
  { 
    if (logging) {
      logPW.println(getTS() +"ms " +msg);
    }
  }
  
  public static void logMessage (Message msg)
  { 
    if (logging) {
    }
  }

  public static void logDocument (Document doc)
  { 
    if (logging) {
    }
  }

  public static void logSent ()
  { 
    if (logging) {
    }
  }

  public static void logReceived ()
  { 
    if (logging) {
    }
  }

  public static void debug (String className, String methodName, String msg)
  {
    if (debugging) {
      logPW.println(getTS() +"ms DEBUG: " +className +"." +methodName +":\n" +msg);
    }
  }

  public static void debug (String className, 
      String methodName, 
      Properties properties) {
    if (debugging) {
      logPW.println(getTS() +"ms DEBUG: " +className +"." +methodName +":\n");
      properties.list(logPW);
    }
  }

  public static void error (String className, String methodName, String msg) {
    error(true, className, methodName, msg);
  }
  
  public static void error (boolean display,
                      String className, 
                      String methodName, 
                      String msg) {
    if (display) {
      System.err.println(getTS() +"ms **ERROR** " +className +"." 
            +methodName +": " +msg);
    }
    logPW.println(getTS() +"ms: ERROR: " +className +"." +methodName +":" +msg);
  }
  
  private static int getTS ()
  {
    Calendar c = Calendar.getInstance();
    return (int)(c.getTimeInMillis() - init_time);
  }
*/
  
  public static void logMessage (Message msg) { 
  }

  public static void logDocument (Document doc) { 
  }

  public static void logSent () { 
  }

  public static void logReceived () { 
  }

  public static void debug (String className, 
      String methodName, 
      Properties properties) {
  }
  
  public static void debug (String className, String methodName, String msg) {
    mmLogger.debug(msg);
    consoleLogger.debug(msg);
  }

  public static void warn (String className, String methodName, String msg) {
    warn(true, className, methodName, msg);
  }
  
  public static void warn (boolean display,
                      String className, 
                      String methodName, 
                      String msg) {
    consoleLogger.warn(msg);
    mmLogger.warn(msg);
  }
  
  public static void error (String className, String methodName, String msg) {
    error(true, className, methodName, msg);
  }
  
  public static void error (boolean display,
                      String className, 
                      String methodName, 
                      String msg) {
    consoleLogger.error(msg);
    mmLogger.error(msg);
  }
  
  public static void log (String msg) { 
    mmLogger.info(msg);
  }
  
  public static void debug (String msg) {
    mmLogger.debug(msg);
    consoleLogger.info(msg);
  }
  
  public static void warn (String msg) {
    consoleLogger.warn(msg);
    mmLogger.warn(msg);
  }
  
  public static void error (String msg) {
    consoleLogger.error(msg);
    mmLogger.error(msg);
  }
}
