/**
 * This class is a dialog to let the user know about a time-consuming process
 */

package gov.nist.hl7maker.util;

// AWT
import java.awt.Dimension;

// Swing
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.JLabel;
import javax.swing.BoxLayout;
import javax.swing.Box;

public class WaitDialog extends JDialog{

    private JLabel lblWait;

    /**
     * Constructor
     * @param waitMsg The message displayed during the wait
     */
    public WaitDialog(String waitMsg) {
	setModal(true);
	setDefaultCloseOperation(JDialog.DO_NOTHING_ON_CLOSE);

	JPanel p = new JPanel();
	p.setLayout(new BoxLayout(p, BoxLayout.PAGE_AXIS));

	JPanel p0 = new JPanel();
	p0.setLayout(new BoxLayout(p0, BoxLayout.LINE_AXIS));
	p0.add(Box.createRigidArea(new Dimension(25, 0)));
	lblWait = new JLabel(waitMsg);
	p0.add(lblWait);
	p0.add(Box.createRigidArea(new Dimension(25, 0)));

	p.add(Box.createRigidArea(new Dimension(0, 15)));
	p.add(p0);
	p.add(Box.createRigidArea(new Dimension(0, 15)));

	getContentPane().add(p);
	pack();
    }

    /**
     * Set the thread to execute
     * @param t The thread
     */

    /**
     * Start the processing
     */
}

