/** 
 * This class is a dialog to show the user what's going on
 */

package gov.nist.hl7maker.util.hapi;

// JDK
import java.util.Observable;
import java.util.Observer;

// AWT
import java.awt.Dimension;

// Swing
import javax.swing.JDialog;
import javax.swing.BoxLayout;
import javax.swing.JPanel;
import javax.swing.JLabel;
import javax.swing.BorderFactory;
import javax.swing.JFrame;

public class GenerationDialog extends JDialog implements Observer {

    private JLabel lblStatus;
    private String profile;

    /**
     * Constructor
     */
    public GenerationDialog(JFrame frame) {
	super(frame, "Customizing HAPI ...", true);


	BoxLayout layout = new BoxLayout(getContentPane(), BoxLayout.PAGE_AXIS);
	getContentPane().setLayout(layout);

	// Label
	JPanel p0 = new JPanel();
	p0.setLayout(new BoxLayout(p0, BoxLayout.LINE_AXIS));
	lblStatus = new JLabel("Customizing HAPI ...");
	lblStatus.setPreferredSize(new Dimension(500, 15));
	p0.add(lblStatus);
	p0.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));

	getContentPane().add(p0);
    }

    /**
     * Set the profile
     * @param profile The profile filename
     */
    public void setProfile(String profile) {
	lblStatus.setText("Customizing HAPI ...");
	this.profile = profile;
    }

    /**
     * MVC
     * @param o The observable object
     * @param arg An argument passed to the notifyObservers method
     */
    public void update(Observable o, Object arg) {
	if(o instanceof CustomHAPI) {
	    if(arg instanceof String) {
		lblStatus.setText((String)arg);
	    }
	    else if(arg instanceof CustomHAPI) {
		setVisible(false);
	    }
	}
    }
    
}
