package gov.nist.hl7maker.verifier;

import gov.nist.hl7maker.verifier.message.BasicMessageVerifier;

import java.io.File;

/**
 * Provides basic verification support to be used when there is no access to a
 * metadata file.
 * 
 * @author Justin Manweiler
 */
public class LimitedVerifierFactory extends AbstractVerifierFactory {

    // --- Constructor ---

    public LimitedVerifierFactory( final File profile ) {
        super( profile );
    }

    // --- Public Methods ---

    public BasicMessageVerifier getMessageVerifier( final File msgFile )
            throws VerifierException {
        return newMessageVerifier( msgFile );
    }


    // --- Private Methods ---

    private BasicMessageVerifier newMessageVerifier( final File message )
            throws VerifierException {
        final BasicMessageVerifier mV = new BasicMessageVerifier( message );
        
        setupMessageVerifier( mV );

        return mV;
    }
}
