package gov.nist.hl7maker.verifier.message;

import java.util.ArrayList;
import java.util.Collection;

/**
 * Stores basic information regarding a message structure.
 * 
 * @author Justin Manweiler
 */
class MessageElement {

    // --- Private Fields ---
    
    private final Collection dValues = new ArrayList();

    private int count = 1;

    // --- Public Methods ---
    
    public int getCount() {
        return count;
    }

    public void increment() {
        count++;
    }

    public void addDataValue( final String dataValue ) {
        dValues.add( dataValue );
    }

    public String[] getDataValues() {
        final String[] dValueArr = new String[dValues.size()];
        dValues.toArray( dValueArr );
        return dValueArr;
    }
}