package gov.nist.hl7maker.verifier.profile;

/**
 * Extends <code>ProfileElement</code> to allow for the storage of length and
 * table data.
 * 
 * @author Justin Manweiler
 */
public class ExtendedProfileElement extends ProfileElement {

    // --- Private Fields ---

    private int maxLength = Integer.MAX_VALUE;
    private String tableID = null;

    // --- Public Methods ---

    public int getMaxLength() {
        return maxLength;
    }

    public String getTableID() {
        return tableID;
    }

    public void setMaxLength( final String value ) {
        if ( value != null ) {
            try {
                maxLength = Integer.parseInt( value );
            }
            catch ( final NumberFormatException e ) {
            }
        }
    }

    public void setTableID( final String value ) {
        tableID = value;
    }
}
