package gov.nist.hl7maker.verifier.xmlverifier;

import java.io.File;

/**
 * Allows for the verification of an XML file based on a constant and pre-known
 * file and type description.
 * 
 * @author Justin Manweiler
 */
public class DefaultXMLVerifier extends AbstractXMLVerifier {

    // --- Private Fields ---

    private final File fileFile;
    private final String fileType;

    // --- Constructors ---

    public DefaultXMLVerifier( final String path, final String type ) {
        fileFile = new File( path );
        fileType = type;
    }

    public DefaultXMLVerifier( final File file, final String type ) {
        fileFile = file;
        fileType = type;
    }

    // --- Public Methods ---

    public File getFile() {
        return fileFile;
    }

    // --- Protected Methods ---

    protected String getFileDescription() {
        return fileType;
    }
}
