/**
 * This class is an about dialog
 */

package gov.nist.hl7maker.view;

// JDK
import java.io.File;

// AWT
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Cursor;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

// Swing
import javax.swing.ImageIcon;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.Box;
import javax.swing.JSeparator;
import javax.swing.JButton;
import javax.swing.JEditorPane;
import javax.swing.JPanel;

public class AboutDialog extends JDialog  {
    
    private ImageIcon iconMM;
    private ImageIcon iconNist;
        
    private JEditorPane output;
    
    public AboutDialog(JFrame frame) {
        super(frame, "About", true);
        initComponents();
    } 
  	
    private void initComponents (){ 
        getContentPane().setBackground(Color.WHITE);
        
        Box aboutBox = Box.createVerticalBox();
        aboutBox.setForeground(Color.white);
        
        // Title BOX
        Box titleBox = Box.createHorizontalBox();
        titleBox.add(Box.createRigidArea(new Dimension(150, 0)));
        
        Box imageNistBox = Box.createHorizontalBox();
        iconNist = createImageIcon("." + File.separator + "images" + File.separator + "nist_logo.gif");
        if (iconNist != null) {
            JPanel panelImageNist = new JPanel()
            {
                protected void paintComponent(Graphics g)
                {
                    g.drawImage(iconNist.getImage(), 0, 0, null);
                    super.paintComponent(g);
                }
            };
            
            int height = (iconNist.getImage().getHeight(iconNist.getImageObserver()));
            int width = (iconNist.getImage().getWidth(iconNist.getImageObserver()));
            panelImageNist.setPreferredSize(new Dimension (width,height));
            panelImageNist.setOpaque( false );
            imageNistBox.add(panelImageNist);
        } 
	else 
            System.out.println("Couldnt find the image path!!! ");
        
        titleBox.add(imageNistBox);
        
        JLabel labelMM = new JLabel("Message Maker");
        labelMM.setFont(new Font("Arial", Font.BOLD, 30));
        titleBox.add(labelMM);
        titleBox.add(Box.createRigidArea(new Dimension(150, 0)));
        
        aboutBox.add(titleBox);
        JSeparator separMiddle = new JSeparator ();
        aboutBox.add(separMiddle);
        
        // Middle Box
        Box middleExtBox = Box.createHorizontalBox();
        
        Box middleBox = Box.createVerticalBox();
        
        middleBox.add(Box.createRigidArea(new Dimension(0, 20)));
        JLabel labelVersion = new JLabel("Version 1.4.0");
        labelVersion.setFont(new Font("Arial", Font.BOLD, 15));
        middleBox.add(labelVersion);
        middleBox.add(Box.createRigidArea(new Dimension(0, 20)));
        
        JLabel labelDevby = new JLabel("Developed by the:");
        labelDevby.setFont(new Font("Arial", Font.PLAIN, 15));
        middleBox.add(labelDevby);
        middleBox.add(Box.createRigidArea(new Dimension(0, 20)));
        
        JLabel labelNIST = new JLabel("National Institute of Standards and Technology");
        labelNIST.setFont(new Font("Arial", Font.BOLD, 20));
        labelNIST.setForeground(new Color(51,102,255));
        middleBox.add(labelNIST);
       
        JLabel labelLab = new JLabel("Information Technology Laboratory");
        labelLab.setFont(new Font("Arial", Font.BOLD, 15));
        middleBox.add(labelLab);
        
        JLabel labelDiv = new JLabel("Software Diagnostics and Conformance Testing Division");
        labelDiv.setFont(new Font("Arial", Font.BOLD, 15));
        middleBox.add(labelDiv);
        middleBox.add(Box.createRigidArea(new Dimension(0, 20)));
        
        JLabel labelColla = new JLabel("In collaboration with the:");
        labelColla.setFont(new Font("Arial", Font.PLAIN, 15));
        middleBox.add(labelColla);
        
        JLabel labelHL7 = new JLabel("HL7 Conformance Special Interest Group");
        labelHL7.setFont(new Font("Arial", Font.BOLD, 20));
        labelHL7.setForeground(new Color(51,102,255));
        middleBox.add(labelHL7);
        middleBox.add(Box.createRigidArea(new Dimension(0, 20)));
        
        JLabel labelContact = new JLabel("<html>Contact: <a href=\"mailto:messagemaker@nist.gov\">messagemaker@nist.gov</a></html>");
        labelContact.setFont(new Font("Arial", Font.BOLD, 10));
	final JLabel fLabelContact = labelContact;
	labelContact.addMouseListener(new MouseListener() {

		public void mouseClicked(MouseEvent e) {
		    if(e.getButton() == MouseEvent.BUTTON1) {
			try {
			    Runtime.getRuntime().exec("cmd /C start mailto:messagemaker@nist.gov");
			} catch (Exception ex) {
			    System.err.println("Exception: " + ex.getMessage());
			    ex.printStackTrace();
			} 	    
		    }
		}

		public void mouseEntered(MouseEvent e) {
		    fLabelContact.setCursor(new Cursor(Cursor.HAND_CURSOR));
		}

		public void mouseExited(MouseEvent e) {
		    fLabelContact.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
		}

		public void mousePressed(MouseEvent e) {;}
		public void mouseReleased(MouseEvent e) {;}
	    });

        middleBox.add(labelContact);

        JLabel labelWebSite = new JLabel("<html>WebSite: <a href=\"http://www.nist.gov/messagemaker\">http://www.nist.gov/messagemaker</a></html>");
        labelWebSite.setFont(new Font("Arial", Font.BOLD, 10));
	final JLabel fLabelWebSite = labelWebSite;
	labelWebSite.addMouseListener(new MouseListener() {

		public void mouseClicked(MouseEvent e) {
		    if(e.getButton() == MouseEvent.BUTTON1) {
			try {
			    Runtime.getRuntime().exec("cmd /C start http://www.nist.gov/messagemaker");
			} catch (Exception ex) {
			    System.err.println("Exception: " + ex.getMessage());
			    ex.printStackTrace();
			} 	    
		    }
		}

		public void mouseEntered(MouseEvent e) {
		    fLabelWebSite.setCursor(new Cursor(Cursor.HAND_CURSOR));
		}

		public void mouseExited(MouseEvent e) {
		    fLabelWebSite.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
		}

		public void mousePressed(MouseEvent e) {;}
		public void mouseReleased(MouseEvent e) {;}
	    });

        middleBox.add(labelWebSite);
        
        middleBox.add(Box.createRigidArea(new Dimension(0, 20)));
        
        middleExtBox.add(Box.createRigidArea(new Dimension(20, 0)));
        middleExtBox.add(middleBox);
        middleExtBox.add(Box.createRigidArea(new Dimension(20, 0)));
        aboutBox.add(middleExtBox);        
        
        JSeparator separBottom = new JSeparator ();
        aboutBox.add(separBottom);
        
        // Contact Box
        Box contactBox = Box.createHorizontalBox();
        contactBox.add(Box.createRigidArea(new Dimension(100, 0)));
        JButton buttonOk = new JButton ("Ok");
	buttonOk.setBackground(new Color(204, 204, 255));
        buttonOk.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                dispose();
            }
        });
        contactBox.add(buttonOk);
        contactBox.add(Box.createRigidArea(new Dimension(100, 0)));
        aboutBox.add(contactBox);
        
        getContentPane().add(aboutBox);
         
  }
    
    /** Returns an ImageIcon, or null if the path was invalid. */
    protected static ImageIcon createImageIcon(String path) {
        File imgURL = new File (path);
        if (imgURL.exists()) {
            return new ImageIcon(path);
        } 
	else {
            System.err.println("Couldn't find file: " + path);
            return null;
        }
    }
}
