/**
 * This class is an about dialog
 */

package gov.nist.hl7maker.view;

// JDK
import java.io.File;

// AWT
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

// Swing
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.Box;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.BoxLayout;
import javax.swing.BorderFactory;

public class ContributorsDialog extends JDialog  {
    
    public ContributorsDialog(JFrame frame) {
        super(frame, "Contributors", true);

	BoxLayout layout = new BoxLayout(getContentPane(), BoxLayout.PAGE_AXIS);
	getContentPane().setLayout(layout);

	JPanel p0 = new JPanel();
	p0.setBackground(Color.WHITE);
	p0.setLayout(new BoxLayout(p0, BoxLayout.LINE_AXIS));
	JLabel lbl1 = new JLabel("This software was designed and written by employees of the National Institute of Standards and Technology (NIST).");
	p0.add(lbl1);

	JPanel p1 = new JPanel();
	p1.setBackground(Color.WHITE);
	p1.setLayout(new BoxLayout(p1, BoxLayout.LINE_AXIS));
	JLabel lblPL = new JLabel("Project Leader: ");
	lblPL.setFont(lblPL.getFont().deriveFont(Font.BOLD));
	JLabel lblRS = new JLabel("Robert Snelick");
	lblRS.setFont(lblRS.getFont().deriveFont(Font.PLAIN));
	p1.add(lblPL);
	//	p1.add(Box.createRigidArea(new Dimension(0, )));
	p1.add(lblRS);

	JPanel p2 = new JPanel();
	p2.setBackground(Color.WHITE);
	p2.setLayout(new BoxLayout(p2, BoxLayout.LINE_AXIS));
	JLabel lblAuthors = new JLabel("Authors: ");
	lblAuthors.setFont(lblAuthors.getFont().deriveFont(Font.BOLD));
	JLabel lblLGSHRS = new JLabel("Len Gebase, Sydney Henrard, Robert Snelick");
	lblLGSHRS.setFont(lblLGSHRS.getFont().deriveFont(Font.PLAIN));
	p2.add(lblAuthors);
	p2.add(lblLGSHRS);

	JPanel p3 = new JPanel();
	p3.setLayout(new BoxLayout(p3, BoxLayout.LINE_AXIS));
	JButton btnOK = new JButton("OK");
	btnOK.setBackground(new Color(204, 204, 255));
        btnOK.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                dispose();
            }
        });
	p3.add(btnOK);

	JPanel p = new JPanel();
	p.setBackground(Color.WHITE);
	p.setLayout(new BoxLayout(p, BoxLayout.PAGE_AXIS));
	p.add(p0);
	p.add(Box.createRigidArea(new Dimension(0, 5)));
	p.add(p1);
	p.add(Box.createRigidArea(new Dimension(0, 5)));
	p.add(p2);
	p.add(Box.createRigidArea(new Dimension(0, 10)));
	p.add(p3);
	p.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));
	getContentPane().add(p);
    }
}
