/**
 * This class is a dialog to show the log
 */

package gov.nist.hl7maker.view;

// JDK
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;

// AWT
import java.awt.Color;
import java.awt.Dimension;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

// Swing
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.BoxLayout;
import javax.swing.Box;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.JButton;
import javax.swing.JScrollPane;
import javax.swing.BorderFactory;

// MessageMaker
/*import gov.nist.hl7maker.control.Session;
  import gov.nist.hl7maker.util.MVCArg;*/

public class LogDialog extends JFrame implements ActionListener {

    private JTextArea txtLog;
    private JScrollPane txtLogPane;
    private JButton btnClose;
    private final String LOGFILE = "log/msgGeneration.log";

    /**
     * Constructor
     */
    public LogDialog() {
	super("Log");

	BoxLayout layout = new BoxLayout(getContentPane(), BoxLayout.PAGE_AXIS);
	getContentPane().setLayout(layout);

	JPanel p = new JPanel();
	p.setLayout(new BoxLayout(p, BoxLayout.PAGE_AXIS));

	// Log JTextArea
	txtLog = new JTextArea();
	txtLog.setEditable(false);
	txtLog.setLineWrap(true);
	txtLogPane = new JScrollPane();
	txtLogPane.getViewport().add(txtLog);
	txtLogPane.setPreferredSize(new Dimension(500,400));
	p.add(txtLogPane);

	p.add(Box.createRigidArea(new Dimension(0, 10)));

	// Close
	JPanel p2 = new JPanel();
	p2.setLayout(new BoxLayout(p2, BoxLayout.LINE_AXIS));
	btnClose = new JButton("Close");
	btnClose.setBackground(new Color(204, 204, 255));
	btnClose.addActionListener(this);
	p2.add(btnClose);
	p.add(p2);

	p.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));
	getContentPane().add(p);
    }

    /**
     * Init the dialog
     */
    public void init() {
	txtLog.setText("");
	try { 
	    BufferedReader br = new BufferedReader(new FileReader(LOGFILE));
	    String line = null;
	    
	    while((line = br.readLine()) != null) {
		txtLog.append(line);
		txtLog.append("\n");
	    }
	    txtLog.moveCaretPosition(0);
	    br.close();
	}
	catch(IOException ioe) {
	    System.err.println("IOException " + ioe.getMessage());
	}
    }

    /**
     * Handles the event
     * @param evt The event
     */
    public void actionPerformed(ActionEvent evt) {
	if(evt.getSource() == btnClose) {
	    setVisible(false);
	}
    }
}
