/**
 * This class is a dialog to show the current profile
 */

package gov.nist.hl7maker.view;

// JDK
import java.io.File;
import java.io.IOException;

// AWT
import java.awt.Color;
import java.awt.Dimension;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

// Swing
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.JButton;
import javax.swing.JScrollPane;
import javax.swing.BoxLayout;
import javax.swing.Box;
import javax.swing.BorderFactory;
import javax.swing.JTree;
import javax.swing.Icon;
import javax.swing.tree.DefaultTreeCellRenderer;

// SAX
import javax.xml.parsers.SAXParserFactory;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.ParserConfigurationException;
import org.xml.sax.SAXException;

// XML
import javax.xml.parsers.DocumentBuilder; 
import javax.xml.parsers.DocumentBuilderFactory;  
import javax.xml.parsers.ParserConfigurationException;

// DOM
import org.w3c.dom.Document;

// MessageMaker
import gov.nist.hl7maker.view.display.XMLFormatter;

public class ProfileDialog extends JFrame implements ActionListener {

    //private JTextArea txtProfile;
    //private JScrollPane txtProfilePane;
    private JTree xmlProfileTree;
    private JScrollPane xmlProfileTreeScrollPane;
    private JButton btnClose;

    /**
     * Constructor
     */
    public ProfileDialog() {
	super("Profile");

	BoxLayout layout = new BoxLayout(getContentPane(), BoxLayout.PAGE_AXIS);
	getContentPane().setLayout(layout);

	JPanel p = new JPanel();
	p.setLayout(new BoxLayout(p, BoxLayout.PAGE_AXIS));

	// Profile JTextArea
/*	txtProfile = new JTextArea();
	txtProfile.setEditable(false);
	txtProfile.setLineWrap(true);
	txtProfilePane = new JScrollPane();
	txtProfilePane.getViewport().add(txtProfile);
	txtProfilePane.setPreferredSize(new Dimension(700,600));
	p.add(txtProfilePane);*/

	xmlProfileTree = new JTree();
	DefaultTreeCellRenderer renderer = new DefaultTreeCellRenderer();
        Icon personIcon = null;
        renderer.setLeafIcon(personIcon);
        renderer.setClosedIcon(personIcon);
        renderer.setOpenIcon(personIcon);
	xmlProfileTree.setCellRenderer(renderer);
	xmlProfileTreeScrollPane = new JScrollPane(xmlProfileTree);
	p.add(xmlProfileTreeScrollPane);

	p.add(Box.createRigidArea(new Dimension(0, 10)));

	// Close
	JPanel p2 = new JPanel();
	p2.setLayout(new BoxLayout(p2, BoxLayout.LINE_AXIS));
	btnClose = new JButton("Close");
	btnClose.setBackground(new Color(204, 204, 255));
	btnClose.addActionListener(this);
	p2.add(btnClose);
	p.add(p2);

	p.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));
	getContentPane().add(p);
    }

    /**
     * Display the profile
     * @param xmlProfile The xml profile filename
     */
    public void displayProfile(String xmlProfile) throws ParserConfigurationException, SAXException, IOException {
	DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
	DocumentBuilder builder = factory.newDocumentBuilder();
	Document doc = builder.parse(new File(xmlProfile));

	ProfileXMLTreeModel xmlTreeModel = new ProfileXMLTreeModel(doc);
	xmlProfileTree.setModel(xmlTreeModel);
    }

/*	txtProfile.setText("");

	XMLFormatter handler = new XMLFormatter();
	handler.setJTextArea(txtProfile);

        SAXParserFactory factory = SAXParserFactory.newInstance();
	SAXParser saxParser = factory.newSAXParser();
	saxParser.parse(new File(xmlProfile), handler);

	txtProfile.moveCaretPosition(0);
	}*/


    /**
     * Handles the event
     * @param evt The event
     */
    public void actionPerformed(ActionEvent evt) {
	if(evt.getSource() == btnClose) {
	    setVisible(false);
	}
    }
}
