/**
 * This class is a panel to access to the data
 */

package gov.nist.hl7maker.view.config;

// JDK
import java.util.Vector;

// AWT
import java.awt.Dimension;

// Swing
import javax.swing.JPanel;
import javax.swing.BoxLayout;
import javax.swing.Box;
import javax.swing.BorderFactory;

// MessageMaker
import gov.nist.hl7maker.control.Session;

public class DataPanel extends JPanel {

    private ValuePanel vp;
    private ValueCommandPanel vcp;
    private ValuePropertiesPanel vpp;
    private ValueSavePanel vsp;
    private ValueDataLinkPanel vdlp;

    /**
     * Constructor
     */
    public DataPanel() {
	BoxLayout layout = new BoxLayout(this, BoxLayout.LINE_AXIS);
	setLayout(layout);

	vp = new ValuePanel();
	add(vp);

	JPanel rightPane = new JPanel();
	rightPane.setLayout(new BoxLayout(rightPane, BoxLayout.PAGE_AXIS));

	rightPane.add(Box.createRigidArea(new Dimension(0,20)));

	vcp = new ValueCommandPanel();
	vcp.setPreferredSize(new Dimension(300,45));
	rightPane.add(vcp);

	rightPane.add(Box.createRigidArea(new Dimension(0,25)));

	vpp = new ValuePropertiesPanel();
	rightPane.add(vpp);

	rightPane.add(Box.createRigidArea(new Dimension(0,25)));

	vsp = new ValueSavePanel();
	rightPane.add(vsp);

	vdlp = new ValueDataLinkPanel();
	rightPane.add(Box.createRigidArea(new Dimension(0, 25)));
	rightPane.add(vdlp);

	//rightPane.add(Box.createRigidArea(new Dimension(0,153)));
	rightPane.add(Box.createRigidArea(new Dimension(0,73)));
	add(Box.createRigidArea(new Dimension(10,0)));
	add(rightPane);

	vp.setValuePropertiesPanel(vpp);
	vcp.setValuePropertiesPanel(vpp);

	setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));
    }

    /**
     * Set the session
     * @param ses The session
     */
    public void setSession(Session ses) {
	vp.setSession(ses);
	vcp.setSession(ses);
	vpp.setSession(ses);
	vsp.setSession(ses);
	vdlp.setSession(ses);
    }
}
