/**
 * This class represents a field in the profile
 */

package gov.nist.hl7maker.view.config;

// JDK
import java.util.Vector;

public class FieldNode extends ProfileNode {

    private Vector vComponent;

    /**
     * Constructor
     */
    public FieldNode() {
	vComponent = new Vector();
    }

    /** 
     * Constructor, create a new FieldNode from a FieldNode, kind of clone
     * @param fn A FieldNode
     */
    public FieldNode(FieldNode fn) {
	this();
	name = fn.getName();
	qualifier = fn.getQualifier();
	segment = fn.getSegment();
	datatype = fn.getDatatype();
	usage = fn.getUsage();
	cardMin = fn.getCardMin();
	cardMax = fn.getCardMax();
	length = fn.getLength();
	itemNo = fn.getItemNo();
	sequenceNum = fn.getSequenceNum();
	parent = fn.getParent();
	batchValue = fn.getBatchValue();
    }

    /**
     * Get the components of the field
     * @return The components
     */
    public Vector getComponents() {
	return vComponent;
    }

    /**
     * Add a component
     * @param component The component
     */
    public void addComponent(ComponentNode component) {
	if(component != null) // && !vComponent.contains(component))
	    vComponent.add(component);
    }

    /**
     * Return true if it is a leaf
     * @return is it a leaf?
     */
    public boolean isLeaf() {
	return vComponent.size() == 0;
    }

    public String getValue() {
	return null;
    }

    public String getMsgLoc() {
	return segment + "." + sequenceNum;
    }
}
