/**
 * This class represents a segment group in the profile
 */

package gov.nist.hl7maker.view.config;

// JDK
import java.util.Vector;

public class SegmentGroupNode extends ProfileNode {

    private Vector vChild;

    /**
     * Constructor
     */
    public SegmentGroupNode() {
	vChild = new Vector();
    }

    /** 
     * Constructor, create a new SegmentGroupNode from a SegmentGroupNode, kind of clone
     * @param sn A SegmentNode
     */
    public SegmentGroupNode(SegmentGroupNode sgn) {
	this();
	name = sgn.getName();
	qualifier = sgn.getQualifier();
	segment = sgn.getSegment();
	datatype = sgn.getDatatype();
	usage = sgn.getUsage();
	cardMin = sgn.getCardMin();
	cardMax = sgn.getCardMax();
	length = sgn.getLength();
	itemNo = sgn.getItemNo();
	parent = sgn.getParent();
    }

    /**
     * Get the children of this segment group
     * @return The fields
     */
    public Vector getChildren() {
	return vChild;
    }

    /**
     * Add a segment or segment group
     * @param child The child
     */
    public void addChild(ProfileNode child) {
	if(child != null) // && !vChild.contains(child))
	    vChild.add(child);
    }

    /**
     * Return true if it is a leaf
     * @return is it a leaf?
     */
    public boolean isLeaf() {
	return vChild.size() == 0;
    }

    public String getValue() {
	return null;
    }

    public String getMsgLoc() {
	return name;
    }
}

