/**
 * This class represents a segment in the profile
 */

package gov.nist.hl7maker.view.config;

// JDK
import java.util.Vector;

public class SegmentNode extends ProfileNode {

    private Vector vField;

    /**
     * Constructor
     */
    public SegmentNode() {
	vField = new Vector();
    }

    /** 
     * Constructor, create a new SegmentNode from a SegmentNode, kind of clone
     * @param sn A SegmentNode
     */
    public SegmentNode(SegmentNode sn) {
	this();
	name = sn.getName();
	qualifier = sn.getQualifier();
	segment = sn.getSegment();
	datatype = sn.getDatatype();
	usage = sn.getUsage();
	cardMin = sn.getCardMin();
	cardMax = sn.getCardMax();
	length = sn.getLength();
	itemNo = sn.getItemNo();
	sequenceNum = sn.getSequenceNum();
	parent = sn.getParent();
    }

    /**
     * Get the fields of the segment
     * @return The fields
     */
    public Vector getFields() {
	return vField;
    }

    /**
     * Add a field 
     * @param field The field
     */
    public void addField(FieldNode field) {
	if(field != null)// && !vField.contains(field))
	    vField.add(field);
    }

    /**
     * Return true if it is a leaf
     * @return is it a leaf?
     */
    public boolean isLeaf() {
	return vField.size() == 0;
    }

    public String getValue() {
	return null;
    }

    public String getMsgLoc() {
	return name;
    }
}

