/**
 * This class represents a table node in hl7 tables
 */

package gov.nist.hl7maker.view.config;

public class TableNode {

    private String id;
    private String type;
    private String name;
    private String version;

    /**
     * Constructor
     */
    public TableNode() {
    }

    // Get Methods
    public String getId() {
	return id;
    }

    public String getName() {
	return name;
    }

    public String getVersion() {
	return "2.4";
    }

    public String getType() {
	return type;
    }

    // Set Methods
    public void setId(String id) {
	this.id = id;
    }

    public void setType(String type) {
	this.type = type;
    }

    public void setName(String name) {
	this.name = name;
    }

    public void setVersion(String version) {
	this.version = version;
    }

    /**
     * Return true if the two objects are equal
     * @param o The other object
     * @return return true if equal
     */
    public boolean equals(Object o) {
	TableNode tn = (TableNode)o;
	boolean equal = true;

	if(id.compareTo(tn.getId()) != 0)
	    equal = false;
	return equal;
    }
}
