/**
 * This class is a panel to access to the data for table value
 */

package gov.nist.hl7maker.view.config;

// JDK
import java.util.Vector;

// AWT
import java.awt.Dimension;

// Swing
import javax.swing.JPanel;
import javax.swing.BoxLayout;
import javax.swing.Box;
import javax.swing.BorderFactory;

// MessageMaker
import gov.nist.hl7maker.control.Session;

public class TablePanel extends JPanel {

    private TableValuePanel tvp;
    private TableValueCommandPanel tvcp;
    private TableValueSavePanel tvsp;
    private TableValueDataLinkPanel tvdlp;

    /**
     * Constructor
     */
    public TablePanel() {
	BoxLayout layout = new BoxLayout(this, BoxLayout.PAGE_AXIS);
	setLayout(layout);

	tvp = new TableValuePanel();
	tvp.setFlag(true);
	add(tvp);

	add(Box.createRigidArea(new Dimension(0, 10)));

	tvcp = new TableValueCommandPanel();
	add(tvcp);

	add(Box.createRigidArea(new Dimension(0, 10)));

	tvsp = new TableValueSavePanel();
	add(tvsp);

	add(Box.createRigidArea(new Dimension(0, 10)));

	/*cfgp = new TableValueConfigPanel();
	  add(cfgp);*/

	add(Box.createRigidArea(new Dimension(0, 10)));

	tvdlp = new TableValueDataLinkPanel();
	add(tvdlp);

	setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));
    }

    /**
     * Set the session
     * @param ses The session
     */
    public void setSession(Session ses) {
	tvp.setSession(ses);
	tvcp.setSession(ses);
	tvsp.setSession(ses);
	tvdlp.setSession(ses);
    }
}
