/**
 * This class represents a table with a priority
 */

package gov.nist.hl7maker.view.config;


// JDK
import java.io.File;
import java.io.IOException;

public class TablePriority {

    private int priority;
    private String filename;

    /**
     * Constructor
     * @param filename The filename
     */
    public TablePriority(String filename) {
	this.filename = filename;
    }

    /**
     * Constructor
     * @param filename The filename
     * @param priority The priority
     */
    public TablePriority(String filename, int priority) {
	this.filename = filename;
	this.priority = priority;
    }

    public String getFilename() {
	return filename;
    }

    public int getPriority() {
	return priority;
    }

    public void setFilename(String filename) {
	this.filename = filename;
    }

    public void setPriority(int p) {
	priority = p;
    }

    public boolean equals(Object o) {
	if(o instanceof TablePriority) {
	    try {
		TablePriority tp = (TablePriority)o;
		return new File(filename).getCanonicalPath().equals(new File(tp.getFilename()).getCanonicalPath());
	    }
	    catch(IOException ioe) {
		System.err.println("IOException " + ioe.getMessage());
		ioe.printStackTrace();
	    }
	}
	return false;
    }

    public String toString() {
	return filename;
    }
}
