/**
 * This class is a Panel for the ER7 View of a message
 */

package gov.nist.hl7maker.view.display;

// JDK
import java.io.File;

// AWT
import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.event.MouseListener;
import java.awt.event.MouseEvent;

// Swing
import javax.swing.JTextArea;

// DOM
import org.w3c.dom.Document;
/*import org.w3c.dom.NodeList;
import org.w3c.dom.Node;
import org.w3c.dom.Element;*/

// HAPI
/*import ca.uhn.hl7v2.parser.DefaultXMLParser;
import ca.uhn.hl7v2.parser.PipeParser;
import ca.uhn.hl7v2.model.Message;
import ca.uhn.hl7v2.HL7Exception;*/

// MessageMaker
/*import gov.nist.hl7maker.util.hapi.CustomHAPI;
  import gov.nist.hl7maker.util.hapi.GenerationDialog;*/

public class ER7View extends JTextArea implements MouseListener {

    //    private DefaultXMLParser xmlParser;
    //    private PipeParser pipeParser;
    private PopUp popUp;
    private String profile;
    private boolean custom;

    /**
     * Constructor
     */
    public ER7View() {
	//	setEditable(false);
	//	xmlParser = new DefaultXMLParser();
	//	pipeParser = new PipeParser();
	addMouseListener(this);
	popUp = new PopUp();

	//dlgGeneration = new GenerationDialog();
    }

    /**
     * Handles a right click
     * @param e The event
     */
    public void mouseClicked(MouseEvent e) {
	if(e.getButton() == 3) {	    
	    popUp.setER7Contents(getText());
	    popUp.show(this, e.getX(), e.getY());
	}
    }
    public void mouseEntered(MouseEvent e) {;}
    public void mouseExited(MouseEvent e) {;}
    public void mousePressed(MouseEvent e) {;}
    public void mouseReleased(MouseEvent e) {;}

    /**
     * Display the message from the xml message
     * @param xmlMessage The XML message filename
     */
    public void displayMessage(String xmlMessage) {
	this.setText("");
	this.append(XMLtoER7.transform(xmlMessage));
    }

    /**
     * Display the message from a DOM
     * @param xmlDoc The XML message in DOM
     */
    public void displayMessage(Document xmlDoc) {
	this.setText("");
	this.append(XMLtoER7.transform(xmlDoc));
    }

    /**
     * Display the message from a DOM
     * @param doc The message as a DOM
     * @param version The HL7 version 
     * @param custom Customize HAPI
     */
/*    public void olddisplayMessage(Document doc, String version, boolean custom) throws HL7Exception {
	// Modify the Document object
	String prefix = "";
	if(custom) {
	    prefix = new File(profile).getName();
	    prefix = prefix.substring(0, prefix.length()-4).replaceAll("_","XX").replaceAll(" ","XX");
	    doc = CustomHAPI.modifyDocument(doc, prefix);
	}

	// Convert to ER7
	xmlParser = new DefaultXMLParser();
	Message msg = xmlParser.parseDocument(doc, version);
	this.setText("");
	this.append(CustomHAPI.cleanER7(formatER7(pipeParser.encode(msg)), prefix));
	}*/

    /**
     * Display the message from a DOM
     * @param doc The message as a DOM
     * @param version The HL7 version 
     */
/*    public void olddisplayMessage(Document doc, String version) throws HL7Exception {
	olddisplayMessage(doc, version, custom);
	}*/

    /**
     * Display the message from a DOM
     * @param profile The profile
     * @param doc The message as a DOM
     * @param version The HL7 version 
     * @param custom Customize HAPI
     */
/*    public void olddisplayMessage(String profile, Document doc, String version, boolean custom) throws HL7Exception {
	// Customize HAPI
	if(!profile.equals(this.profile)) {
	    this.profile = profile;
	}
	this.custom = custom;
	
	olddisplayMessage(doc, version, custom);
	}*/

    /**
     * Display the message from a String
     * @param er7 The message as a String
     */
/*    public void olddisplayMessage(String er7) {
	this.setText("");
	this.append(er7);
	}*/

    /**
     * Format the ER7, it means add CR after each segment
     * @param er7 The ER7 unformatted
     * @return The ER7 formatted
     */
    public static String formatER7(String er7) {
	StringBuffer buffy = new StringBuffer();
	for(int i=0;i<er7.length();i++) {
	    if(er7.charAt(i) == 0x0D)
		buffy.append("\n");
	    else
		buffy.append(er7.charAt(i));
	}
	return new String(buffy);
    }

    /**
     * Reset the display
     */
    public void reset() {
	setText("");
    }
}
