/**
 * This panel shows the meta data of a generation process
 */

package gov.nist.hl7maker.view.display;

// AWT
import java.awt.Dimension;
import java.awt.Color;

// Swing
import javax.swing.JPanel;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JTextArea;
import javax.swing.BoxLayout;
import javax.swing.Box;
import javax.swing.BorderFactory;

public class MetaDataPanel extends JPanel {

    private JTextField txtHL7Version;
    private JTextField txtSession;
    private JTextField txtProfile;
    private JTextField txtMsgPath;
    private JTextField txtDate;
    private JTextField txtOrganization;
    //    private JTextField txtDescription;
    private JTextArea txtDescription;
    private JTextField txtVolume;
    private JTextField txtCardinality;
    private JTextField txtUsage;
    private JTextField txtType;

    public MetaDataPanel() {
	BoxLayout layout = new BoxLayout(this, BoxLayout.PAGE_AXIS);
	setLayout(layout);

	// HL7Version
	JPanel p0 = new JPanel();
	p0.setLayout(new BoxLayout(p0, BoxLayout.LINE_AXIS));
	JLabel lblHL7Version = new JLabel("HL7 Version: ");
	p0.add(Box.createRigidArea(new Dimension(12, 0)));
	p0.add(lblHL7Version);
	txtHL7Version = new JTextField("BLA BLA");
	txtHL7Version.setEnabled(false);
	txtHL7Version.setBackground(Color.WHITE);
	p0.add(txtHL7Version);

	add(p0);
	add(Box.createRigidArea(new Dimension(0, 10)));

	// Session
	JPanel p1 = new JPanel();
	p1.setLayout(new BoxLayout(p1, BoxLayout.LINE_AXIS));
	JLabel lblSession = new JLabel("Session: ");
	p1.add(Box.createRigidArea(new Dimension(35, 0)));
	p1.add(lblSession);
	txtSession = new JTextField("BLA BLA");
	txtSession.setEnabled(false);
	txtSession.setBackground(Color.WHITE);
	p1.add(txtSession);

	add(p1);
	add(Box.createRigidArea(new Dimension(0, 10)));

	// Profile
	JPanel p2 = new JPanel();
	p2.setLayout(new BoxLayout(p2, BoxLayout.LINE_AXIS));
	JLabel lblProfile = new JLabel("Profile: ");
	p2.add(Box.createRigidArea(new Dimension(44, 0)));
	p2.add(lblProfile);
	txtProfile = new JTextField("BLA BLA");
	txtProfile.setEnabled(false);
	txtProfile.setBackground(Color.WHITE);
	p2.add(txtProfile);

	add(p2);
	add(Box.createRigidArea(new Dimension(0, 10)));

	// MsgPath
	JPanel p3 = new JPanel();
	p3.setLayout(new BoxLayout(p3, BoxLayout.LINE_AXIS));
	JLabel lblMsgPath = new JLabel("Message Path: ");
	p3.add(Box.createRigidArea(new Dimension(0, 0)));
	p3.add(lblMsgPath);
	txtMsgPath = new JTextField("BLA BLA");
	txtMsgPath.setEnabled(false);
	txtMsgPath.setBackground(Color.WHITE);
	p3.add(txtMsgPath);

	add(p3);
	add(Box.createRigidArea(new Dimension(0, 10)));

	// Date
	JPanel p4 = new JPanel();
	p4.setLayout(new BoxLayout(p4, BoxLayout.LINE_AXIS));
	JLabel lblDate = new JLabel("Date: ");
	p4.add(Box.createRigidArea(new Dimension(55, 0)));
	p4.add(lblDate);
	txtDate = new JTextField("BLA BLA");
	txtDate.setEnabled(false);
	txtDate.setBackground(Color.WHITE);
	p4.add(txtDate);

	add(p4);
	add(Box.createRigidArea(new Dimension(0, 10)));

	// Organization
	JPanel p5 = new JPanel();
	p5.setLayout(new BoxLayout(p5, BoxLayout.LINE_AXIS));
	JLabel lblOrganization = new JLabel("Organization: ");
	p5.add(Box.createRigidArea(new Dimension(9, 0)));
	p5.add(lblOrganization);
	txtOrganization = new JTextField("BLA BLA");
	txtOrganization.setEnabled(false);
	txtOrganization.setBackground(Color.WHITE);
	p5.add(txtOrganization);

	add(p5);
	add(Box.createRigidArea(new Dimension(0, 10)));

	// Description
	JPanel p6 = new JPanel();
	p6.setLayout(new BoxLayout(p6, BoxLayout.LINE_AXIS));
	JLabel lblDescription = new JLabel("Description: ");
	p6.add(Box.createRigidArea(new Dimension(16, 0)));
	p6.add(lblDescription);
	txtDescription = new JTextArea("BLA BLA", 2, 3);
	txtDescription.setLineWrap(true);
	txtDescription.setWrapStyleWord(true);
	txtDescription.setEnabled(false);
	txtDescription.setBackground(Color.WHITE);
	p6.add(txtDescription);

	add(p6);
	add(Box.createRigidArea(new Dimension(0, 10)));

	// Volume
	JPanel p7 = new JPanel();
	p7.setLayout(new BoxLayout(p7, BoxLayout.LINE_AXIS));
	JLabel lblVolume = new JLabel("Volume: ");
	p7.add(Box.createRigidArea(new Dimension(38, 0)));
	p7.add(lblVolume);
	txtVolume = new JTextField("BLA BLA");
	txtVolume.setEnabled(false);
	txtVolume.setBackground(Color.WHITE);
	p7.add(txtVolume);

	add(p7);
	add(Box.createRigidArea(new Dimension(0, 10)));

	// Cardinality
	JPanel p8 = new JPanel();
	p8.setLayout(new BoxLayout(p8, BoxLayout.LINE_AXIS));
	JLabel lblCardinality = new JLabel("Cardinality: ");
	p8.add(Box.createRigidArea(new Dimension(21, 0)));
	p8.add(lblCardinality);
	txtCardinality = new JTextField("BLA BLA");
	txtCardinality.setEnabled(false);
	txtCardinality.setBackground(Color.WHITE);
	p8.add(txtCardinality);

	//add(p8);
	//add(Box.createRigidArea(new Dimension(0, 10)));

	// Usage
	JPanel p9 = new JPanel();
	p9.setLayout(new BoxLayout(p9, BoxLayout.LINE_AXIS));
	JLabel lblUsage = new JLabel("Usage: ");
	p9.add(Box.createRigidArea(new Dimension(45, 0)));
	p9.add(lblUsage);
	txtUsage = new JTextField("BLA BLA");
	txtUsage.setEnabled(false);
	txtUsage.setBackground(Color.WHITE);
	p9.add(txtUsage);

	//add(p9);
	//add(Box.createRigidArea(new Dimension(0, 10)));

	// Type
	JPanel p10 = new JPanel();
	p10.setLayout(new BoxLayout(p10, BoxLayout.LINE_AXIS));
	JLabel lblType = new JLabel("Validity: ");
	p10.add(Box.createRigidArea(new Dimension(40, 0)));
	p10.add(lblType);
	txtType = new JTextField("BLA BLA");
	txtType.setEnabled(false);
	txtType.setBackground(Color.WHITE);
	p10.add(txtType);

	add(p10);
	add(Box.createRigidArea(new Dimension(0, 350)));

	setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
    }

    /**
     * Display the metadata
     * @param metadata The Metadata object
     */
    public void displayMetaData(MetaData metadata) {
	txtHL7Version.setText(metadata.getHL7Version());
	txtSession.setText(metadata.getSession());
	txtProfile.setText(metadata.getProfile());
	txtMsgPath.setText(metadata.getMsgPath());
	txtDate.setText(metadata.getDate());
	txtOrganization.setText(metadata.getOrganization());
	txtDescription.setText(metadata.getDescription());
	txtVolume.setText(metadata.getVolume());
	//txtCardinality.setText(metadata.getCardinality());
	//txtUsage.setText(metadata.getUsage());
	txtType.setText(metadata.getType());
    }
}
