/** 
 * This class is like a JLabel but you can add text with different color
 */

package gov.nist.hl7maker.view.display;

// JDK
import java.util.Vector;

// AWT
import java.awt.Color;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Dimension;

// Swing
import javax.swing.JPanel;
import javax.swing.JLabel;

public class MultiColorLabel extends JPanel {

    private Vector vLabel = new Vector();

    /**
     * Constructor
     */    
    public MultiColorLabel() {
	setLayout(new FlowLayout(FlowLayout.LEFT, 0, 0));
	setBackground(Color.WHITE);
    }

    /**
     * Add a text with a color
     * @param txt The text
     * @param color The color
     */
    public void addText(String txt, Color color) {
	JLabel lbl = new JLabel(txt);
	lbl.setForeground(color);
	add(lbl);
	vLabel.add(lbl);
    }

    /**
     * Calculate the size of the component
     */
    public void setSize() {
	int height = 0, width = 0;
	for(int i=0;i<vLabel.size();i++) {
	    JLabel lbl = (JLabel)vLabel.get(i);
	    Font font = lbl.getFont();
	    FontMetrics fm = lbl.getFontMetrics(font);
	    if(fm.getHeight() > height) {
		height = fm.getHeight();
	    }
	    String txt = lbl.getText();
	    char[] chars = new char[txt.length()+1];
	    txt.getChars(0, txt.length(), chars, 0);
	    width += fm.charsWidth(chars, 0, chars.length);
	}
	// Set the preferredSize
	setPreferredSize(new Dimension((int)(width*1.5), height));
    }
}
