/** 
 * This class is a custom TreeCellEditor
 */

package gov.nist.hl7maker.view.display;

// AWT
import java.awt.Component;
import java.awt.event.MouseEvent;

// Swing
import javax.swing.JTree;
import javax.swing.tree.DefaultTreeCellEditor;
import javax.swing.tree.DefaultTreeCellRenderer;

// DOM
import org.w3c.dom.Node;

public class MyTreeCellEditor extends DefaultTreeCellEditor {

    private Object value;

    /**
     * Constructor
     */
    public MyTreeCellEditor(JTree tr, DefaultTreeCellRenderer rend) {
	super(tr, rend);
    }

    public Component getTreeCellEditorComponent(JTree tree, Object value, boolean isSelected, boolean expanded, boolean leaf, int row) {
	this.value = value;
	value = ((MyNode)value).getFirstNodeValue();
	Component c = super.getTreeCellEditorComponent(tree, value, isSelected, expanded, leaf, row);
	return c;
    }

    public boolean isCellEditable(java.util.EventObject e) {
        MouseEvent me = (MouseEvent)e;
	JTree treeSrc = (JTree)me.getSource();
	MyNode n = (MyNode)treeSrc.getClosestPathForLocation(me.getX(),me.getY()).getLastPathComponent();        
	if(n.isLeaf()) {
	    return true;
	}
	return false;
    }
}
