/** 
 * This class is a custom TreeCellEditor
 */

package gov.nist.hl7maker.view.display;

// AWT
import java.awt.Component;
import java.awt.Color;

// Swing
import javax.swing.JTree;
import javax.swing.tree.DefaultTreeCellRenderer;

// DOM
import org.w3c.dom.Node;

public class MyTreeCellRenderer extends DefaultTreeCellRenderer {

    /**
     * Constructor
     */
    public Component getTreeCellRendererComponent(JTree tree, Object value, boolean sel, boolean expanded, boolean leaf, int row, boolean hasFocus) {
	if(value instanceof MyNode) {
	    MultiColorLabel mcl = new MultiColorLabel();
	    Node n = ((MyNode)value).getNode();
	    if(n.getNodeType() == Node.ELEMENT_NODE) {
		mcl.addText(n.getNodeName(), Color.BLACK);
		if(n.hasChildNodes()) {
		    if(n.getChildNodes().getLength() == 1) {
			Node n1 = n.getChildNodes().item(0);
			if(n1.getNodeType() == Node.TEXT_NODE) {
			    mcl.addText("       " + n.getChildNodes().item(0).getNodeValue(), Color.BLUE);			
			}
		    }
		}
	    }
	    mcl.setSize();
	    return mcl;
	}
	return super.getTreeCellRendererComponent(tree, value, sel, expanded, leaf, row, hasFocus);
    }
}
