/**
 * This class allows the user to choose the directory of messages to display
 * and sort them by profile
 */

package gov.nist.hl7maker.view.display;

// JDK
import java.io.File;
import java.io.IOException;

// Swing
import javax.swing.JPanel;
import javax.swing.JFileChooser;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JFileChooser;
import javax.swing.JButton;
import javax.swing.BoxLayout;
import javax.swing.Box;
import javax.swing.BorderFactory;
import javax.swing.event.ChangeListener;
import javax.swing.event.ChangeEvent;
import javax.swing.filechooser.FileFilter;
import javax.swing.tree.DefaultMutableTreeNode;

// AWT
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.Dimension;
import java.awt.Component;
import java.awt.Color;

public class PanelDirProfileSelector extends JPanel implements ActionListener, ChangeListener {

    private JPanel panelDir;
    private JButton btnMount;
    private JButton btnUnMount;
    //    private JLabel lblDir;
    //    private JButton btnDirChooser;
    //    private JCheckBox chkSort;
    //    private XMLDirectory xmlDir;
    private MessageTree mt;

    /**
     * Constructor
     */
    public PanelDirProfileSelector() {
	setLayout(new BoxLayout(this, BoxLayout.PAGE_AXIS));
	
	//add(Box.createRigidArea(new Dimension(0, 5)));

	JPanel p0 = new JPanel();
	p0.setLayout(new BoxLayout(p0, BoxLayout.LINE_AXIS));
	p0.setAlignmentX(Component.LEFT_ALIGNMENT);
	p0.add(Box.createRigidArea(new Dimension(10, 0)));
	btnMount = new JButton("Mount ...");
	btnMount.setBackground(new Color(204, 204, 255));
	btnMount.addActionListener(this);
	p0.add(btnMount);
	p0.add(Box.createRigidArea(new Dimension(10, 0)));
	btnUnMount = new JButton("UnMount");
	btnUnMount.setBackground(new Color(204, 204, 255));
	btnUnMount.addActionListener(this);
	p0.add(btnUnMount);

	add(Box.createRigidArea(new Dimension(0,5)));
	add(p0);
	add(Box.createRigidArea(new Dimension(0,5)));



/*	JPanel p0 = new JPanel();
	p0.setLayout(new BoxLayout(p0, BoxLayout.LINE_AXIS));
	p0.setAlignmentX(Component.LEFT_ALIGNMENT);

	p0.add(Box.createRigidArea(new Dimension(10, 0)));

	lblDir = new JLabel("");
	p0.add(lblDir);

	add(p0);

	JPanel p = new JPanel();
	p.setLayout(new BoxLayout(p, BoxLayout.LINE_AXIS));
	p.setAlignmentX(Component.LEFT_ALIGNMENT);

	p.add(Box.createRigidArea(new Dimension(10, 0)));

	btnDirChooser = new JButton("Browse ...");
	btnDirChooser.setBackground(new Color(204, 204, 255));
	btnDirChooser.addActionListener(this);
	p.add(btnDirChooser);

	p.add(Box.createRigidArea(new Dimension(10, 0)));

	chkSort = new JCheckBox("Sort by profile");
	chkSort.addChangeListener(this);
	p.add(chkSort);
	
	add(Box.createRigidArea(new Dimension(0,5)));
	add(p);
	add(Box.createRigidArea(new Dimension(0,5)));*/
    }

    /**
     * Set the XMLDirectory
     * @param xmlDir The XMLDirectory
     */
    public void oldsetXMLDirectory(XMLDirectory xmlDir) {
	/*this.xmlDir = xmlDir;
	try {
	    lblDir.setText(new File(xmlDir.getDirectory()).getCanonicalPath());
	}
	catch(IOException ioe) {
	    System.err.println("IOException " + ioe.getMessage());
	    ioe.printStackTrace();
	}*/
    }

    /**
     * Set the MessageTree
     * @param mt The MessageTree
     */
    public void setMessageTree(MessageTree mt) {
	this.mt = mt;
    }

    /**
     * Handles action on click
     * @param e The event
     */
    public void actionPerformed(ActionEvent e) {
/*	if(e.getSource() == btnDirChooser) {
	    JFileChooser fc = new JFileChooser(".");
	    fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
	    int returnVal = fc.showOpenDialog(this);
	    if(returnVal == JFileChooser.APPROVE_OPTION) {
		lblDir.setText(fc.getSelectedFile().getPath());
		xmlDir = new XMLDirectory(fc.getSelectedFile().getAbsolutePath());
		mt.updateMessageList(xmlDir);
	    }
	    }*/
	if(e.getSource() == btnMount) {
	    JFileChooser fc = new JFileChooser(".");
	    fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
	    int returnVal = fc.showOpenDialog(this);
	    if(returnVal == JFileChooser.APPROVE_OPTION) {
		//lblDir.setText(fc.getSelectedFile().getPath());
		XMLDirectory xmlDir = new XMLDirectory(fc.getSelectedFile().getAbsolutePath());
		mt.updateMessageList(xmlDir);
	    }
	}
    }

    /**
     * Handles action on checkbox click
     * @param e The event
     */
    public void stateChanged(ChangeEvent e) {
	/*if(e.getSource() == chkSort) {
	    mt.updateMessageList(xmlDir);
	    }*/
    }
}
