/**
 * This class is a popup to copy/paste ER7
 */

package gov.nist.hl7maker.view.display;

// JDK
import java.io.IOException;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

// AWT
import java.awt.Toolkit;
import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.StringSelection;

// Swing
import javax.swing.JPopupMenu;
import javax.swing.JMenuItem;

public class PopUp extends JPopupMenu implements ActionListener {

    private JMenuItem copy;
    private String ER7Contents;

    /**
     * Constructor
     */
    public PopUp() {
	copy = new JMenuItem("Copy ER7 data to the clipboard");
	copy.addActionListener(this);
	add(copy);
    }

    /**
     * Set the ER7View contents
     * @param sER7 The ER7View contents
     */
    public void setER7Contents(String sER7) {
	ER7Contents = sER7;
    }

    /**
     * Handle a click on the JPopupMenu
     * @param e The event
     */
    public void actionPerformed(ActionEvent e) {
	Clipboard clipboard = Toolkit.getDefaultToolkit().getSystemClipboard();
	StringSelection value = new StringSelection(ER7Contents);
	clipboard.setContents(value, value);
    }
}
