/**
 * This class is a popup for the message tree
 */

package gov.nist.hl7maker.view.display;

// AWT
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

// Swing
import javax.swing.JPopupMenu;
import javax.swing.JMenuItem;
import javax.swing.JDialog;
import javax.swing.JOptionPane;

public class TreePopUp extends JPopupMenu implements ActionListener {

    private JMenuItem unmountDir;
    private XMLDirectory curXMLDirectory;
    private MessageTree mt;

    /**
     * Constructor
     */
    public TreePopUp(MessageTree mt) {
	this.mt = mt;
	unmountDir = new JMenuItem("Unmount directory");
	unmountDir.addActionListener(this);
	add(unmountDir);    
    }

    /**
     * Handles a click on the JPopUpMenu
     * @param evt The event
     */
    public void actionPerformed(ActionEvent evt) {
	if(evt.getSource() == unmountDir) {
	    JOptionPane optionPane = new JOptionPane("Do you want to unmount this directory?",JOptionPane.QUESTION_MESSAGE,JOptionPane.YES_NO_OPTION);
	    JDialog dialog = optionPane.createDialog(this, "Unmount the directory");
	    dialog.show();
	    Object selectedValue = optionPane.getValue();
	    
	    if(selectedValue != null && ((Integer)selectedValue).intValue() == 0) {
		mt.unMountDir(curXMLDirectory);
	    }
	}
    }

    /**
     * Set the current XMLDirectory
     * @param xmlDir
     */
    public void setCurrentXMLDirectory(XMLDirectory xmlDir) {
	curXMLDirectory = xmlDir;
	unmountDir.setEnabled(curXMLDirectory != null);
    }
}
