/** 
 * This class represents a node which handles messages
 */

package gov.nist.hl7maker.view.management;

// JDK
import java.util.Vector;

public class MessageNode {

    private Vector vMsg;

    /**
     * Constructor
     */
    public MessageNode() {
	vMsg = new Vector();
    }

    /**
     * Get the messages
     * @return The messages
     */
    public Vector getMessage() {
	return vMsg;
    }

    /**
     * Add a message
     * @param msg The message filename
     */
    public void addMessage(String msg) {
	if(!vMsg.contains(msg))
	    vMsg.add(msg);
    }

    /**
     * Remove a message
     * @param msg The message filename
     */
    public void removeMessage(String msg) {
	vMsg.remove(msg);
    }

    /**
     * toString implementation
     * @return The String representation
     */
    public String toString() {
	return "Messages";
    }
}
