<?xml version="1.0"?>

<!--	The input XML message properties file looks like:

<MMmessageProperties HL7Version="2.4" Profile="Name_of_Profile">
	<MetaData Name="Example" OrgName="NIST" Version="1.0"/>

	<property name="propertyName" value="propertyValue" />
		  	...
	
  <MessageVariant fileName="outputMessageFileName">
  	<property name="propertyName" value="propertyValue" />
    			...
          
		<Description> Comment </Description>
	</MessageVariant>
  			...

</MMmessageList>  

      Author:  Len Gebase, NIST
    -->  
<xsl:stylesheet version="1.0" 
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:output method="text"/>

<xsl:strip-space elements="*"/>

<xsl:variable name="newline"> 
<xsl:text>
</xsl:text>
</xsl:variable>

<xsl:template match="/">
  <xsl:apply-templates select="MMmessageProperties"/>
</xsl:template>
  
<xsl:template match="MMmessageProperties">
  <xsl:apply-templates select="property"/>
  <xsl:value-of select="'%EofProperties%'"/>
  <xsl:value-of select="$newline"/>
  <xsl:apply-templates select="MessageVariant"/>
</xsl:template>  
  
<xsl:template	match="property">
  <xsl:value-of select="@name"/>
  <xsl:value-of select="' '"/>
  <xsl:value-of select="@value"/>
  <xsl:value-of select="$newline"/>
</xsl:template>

<xsl:template	match="MessageVariant">
  <xsl:if test="@fileName != ''">
	  <xsl:value-of select="'filename '"/>
	  <xsl:value-of select="@fileName"/>
	  <xsl:value-of select="$newline"/>  
  </xsl:if>
	<xsl:apply-templates select="property"/>
  <xsl:value-of select="'%EofMessage%'"/>
  <xsl:value-of select="$newline"/>
</xsl:template>

</xsl:stylesheet>
